const hash = require('./hash');

module.exports = (algorithm, difficulty) => {
  const problem = {
    current: hash(algorithm, `${new Date().getTime()}`),
    previous: '',
  };

  return {
    get: () => {
      return {
        algorithm,
        difficulty,
        problem: problem.current,
      };
    },
    solve: (solution) => {
      // If the solution was correct, create a new problem and return true.
      if (hash(algorithm, problem.current + solution).endsWith('0'.repeat(difficulty))) {
        const previous = problem.previous;
        problem.previous = problem.current;
        problem.current = hash(algorithm, `${previous}${new Date().getTime()}`);
        return true;
      }

      // If the solution was not correct, return false.
      return false;
    },
  };
};
